varying vec4 position;
varying vec3 normal;

/*	Color and gloss descripe the material attributes
	of the rendered object.
*/
uniform vec3 color;
uniform float gloss;

void main()
{
	/*	The first step in deferred shading is a simple pass-through.
		Just write every variable we might need later on into a 
		separate color buffer. Because we're using float buffers, this
		is quite easy.
		
		Note that this is a truly wasteful and unoptimized way, especially
		since FloatFramebuffers are slow too!
		There are a lot of articles how to improve this, eg. the position 
		normal can be recomputed and could be stores with 2 floats each,
		but for clarity, we won't deal with optimizations here.
	*/
	gl_FragData[0] = position;
	gl_FragData[1] = vec4(normal, 1.0);
	gl_FragData[2] = vec4(color, gloss);
}