
varying vec4 position;
varying vec3 normal;

uniform mat4 modelMatrix;
uniform mat4 viewMatrix;

void main()
{
	/*	Rebuild the std. pipeline. We need to do this, because we want the 
		view and the modelmatrices seperate from each other.
	*/
	position = modelMatrix * gl_Vertex;
	gl_Position = gl_ProjectionMatrix * viewMatrix * position;
	
	/*	This holds only true for uniform scaling. The correct matrix would be 
		the transposed inverse of the modelMatrix. 
	*/
	normal = (modelMatrix * vec4(gl_Normal, 0.0)).xyz;
}